function [mVec, segfault, outPath, inPath] = blossom_mex_fake(nNodes, ri, rj, rw)
% blossom_mex_fake  Copy the interface of blossom_mex. For debugging.

    graphPath = tempname;
    outPath   = tempname;    

    nEdges = length(ri);
    
    fid = fopen(graphPath, 'w');
    fprintf(fid, 'c graph in DIMACS format\n');
    fprintf(fid, 'p edge %d %d\n', nNodes, nEdges);
    for e = 1:nEdges
        fprintf(fid, 'e %d %d %d\n', ri(e), rj(e), rw(e));
    end
    fclose(fid);

    cmd = sprintf('./blossom5-v2.03.src/blossom5 -e %s -w %s', graphPath, outPath);    
    [status, out] = system(cmd);        
    
    % Sometimes we may segfault, which means infeasible?
    mVec = 0;        
    if status == 139
        M = [];
        cost = [];
        infeasible = true;
        warning('Warning: segfaulted!');
        setfault = true;
        return;
    end
    
    segfault = false;
    
    mPairs = load(outPath) + 1;
end

