function [B,S]=bmatching(X,k)
%
% function [B,S]=bmatching(X,k)
% 
% Bmatching with at least k connections
% outputs B is an adjacency matrix
% outputs S is the star pattern
%

[n,d]=size(X);

D=zeros(n,n);
for i=1:n
  for j=1:n
    D(i,j)=sum((X(i,:)~=X(j,:)));
  end
end
D = D+rand(size(D))*1e-4;
N = n*n;
f = -reshape(max(max(D))-D,n*n,1);
A = []; b = []; Aeq = []; beq = [];
for i=1:n
  A1 = zeros(1,N);
  for j=1:n
    A1(n*(i-1)+j)=1;
  end
  A = [A; A1];
  b = [b; k];
end
for i=1:n
  A1 = zeros(1,N);
  for j=1:n
    A1(n*(j-1)+i)=1;
  end
  A = [A; A1];
  b = [b; k];
end
x=linprog(f,A,b,Aeq,beq,zeros(size(f)),ones(size(f)));
B = zeros(n,n);
for i=1:n
for j=1:n
  B(i,j)=x(n*(j-1)+i);
end
end
S=zeros(size(X));
for i=1:n
  for j=1:n
    if (B(i,j)>0.5)
      for dd=1:d
        if (X(i,dd)~=X(j,dd))
          S(i,dd)=1;
        end
      end
    end
  end
end


