function extract(fi, ik, varargin)

    p = inputParser; 
    p.addRequired('fi', @isscalar);
    p.addRequired('ik', @isscalar);
    p.addParamValue('vbTempInit', -1);
    p.addParamValue('uniTempInit', 1);
    
    p.parse(fi, ik, varargin{:});
    o = p.Results;
    
    dbstop if error;

    files{1}='bupa.bin';
    files{2}='wine.bin';
    files{3}='heart.bin';
    files{4}='ecoli.bin';
    files{5}='hepatitis.bin';
    files{6}='wdbc.mat';
    files{7}='auto-mpg.mat';
    files{8}='forestfires.mat';    

    % Just make the data smaller.
    for ik = 1:2
        for fi = 1:8        

            kkVec = 20:-6:1;
            kk = kkVec(ik);

            %% Single fi iteration
            if fi > 5
                ss = load(files{fi});
                dataS = double(ss.data);
            else
                dataS=load(files{fi});
            end

            [N, D] = size(dataS);
            if mod(N, 2) == 1 % odd
                dataS(end,:) = [];
            end

            aggPath = sprintf('uci_results/runagg_8set%d.%d.mat', fi, kk);
            agg = load(aggPath);

        %    % Cold start the VB.
        %    [B, S, W] = gvbm(dataS, kk, 'gvbm_uci_vb_runlog_3', 'symmetric', false, 'tempInit', o.vbTempInit);
        %    s = sprintf('uci_results/run_8set_cold_%d.%d.mat', fi, kk);
        %    save(s, 'B', 'S', 'W');
        %    vbStars = sum(S(:));    

            s = sprintf('uci_results/run_8set_cold_%d.%d.mat', fi, kk);
            vb = load(s);
            vbStars = sum(vb.S(:));  
            W = vb.W;

            %tInit = max(W(:));
            tInit = o.uniTempInit; 
            
            outfile = sprintf('8set_graphexample%d.%d.mat', fi, ki);

            [B, S] = gvbm_fake_write(dataS, kk, outfile, 'symmetric', true, 'roundMe', false, 'tempInit', o.uniTempInit, 'Winit', W / tInit);
        end
    end
end
