function extract_social()
    global clicLab
    
    if clicLab        
        dataPath = '/proj/learning/Matching/facebook100';
    else
        dataPath = '/Users/kuitang/Datasets/facebook100';
    end

    social{1} = 'Caltech36';
    social{2} = 'Reed98';
    social{3} = 'Haverford76';
    social{4} = 'Simmons81'
    nFeatures = 7;

    kkVec = 26:-6:6;
    for fi = 1:2    
        for ki = 1:length(kkVec)
            maxKK = kkVec(ki);
            raw = load(fullfile(dataPath, social{fi}));
            friends = full(sum(raw.A, 2));
            logFriends = ceil(log(friends));
            
            %bBase = (max(logFriends1) - logFriends1 + 1) ./ logFriends1;
            bBase = max(logFriends) - logFriends;
            maxBBase = max(bBase);
            
            X = binarizeLocalInfo(raw.local_info);
            N = size(X, 1);
            
            if mod(N, 2) == 1
                X(end,:) = [];
                N = N - 1;
                bBase(end) = [];
                logFriends(end) = [];
            end
            
            minKK = maxKK - maxBBase;
            b = minKK + bBase
            
            aggPath = sprintf('social_4set_runagg%d.%d.mat', fi, maxKK);
            agg     = load(aggPath);

            % We run out of memory without roundMe!
            outfile = sprintf('social_4set_graphexample%d.%d.mat', fi, ki);            
            [B, S] = gvbm_fake_write(X, b, outfile, 'symmetric', true, 'Ginit', agg.B2, 'tempInit', 1, 'roundMe', true);
        end
    end
end
