dbstop if error;

%% Paths
addpath blossom

%% Convert text files to MATLAB matrices
%data = load('bupa.txt');
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii bupa.bin data
%
%data = load('wine.txt');
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii wine.bin data
%
%load('heart.mat');
%data = [xxx yyy];
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii heart.bin data
%
%load('ecoli.mat');
%data = [xxx yyy];
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii ecoli.bin data
%

%%
% load('hepatitis.mat');
% data = [xxx yyy];
% [n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii hepatitis.bin data
%
%


% %% Extra datasets
% % http://archive.ics.uci.edu/ml/datasets/Breast+Cancer+Wisconsin+%28Diagnostic%29
% data = csvread('wdbc.txt', 0, 2);
% [n,d] = size(data);
% data = binarize(data, []);
% save wdbc.bin data
% 
% %http://archive.ics.uci.edu/ml/datasets/Auto+MPG
% %Variables 2, 7, 8 are discrete
% data = csvread('auto-mpg.csv');
% data = binarize(data, [2 7 8]);
% save auto-mpg.bin data
% 
% % Variables 1, 2, 3, 4 are discrete
% data = csvread('forestfires.csv', 1, 0);
% data = binarize(data, [1 2 3 4]);
% save forestfires.bin data

%%
matlabpool open 8;
dbstop if error;

%% Run the algos
files{1}='bupa.bin';
files{2}='wine.bin';
files{3}='heart.bin';
files{4}='ecoli.bin';
files{5}='hepatitis.bin';
files{6}='wdbc.mat';
files{7}='auto-mpg.mat';
files{8}='forestfires.mat';

nFiles = length(files);

kkVec = 20:-6:1;
nKK   = length(kkVec);

%% parfor
parfor fi=1:nFiles
    %% Do stuff
    % Hackiness for parfor
    
    %% Single fi iteration
    
    if fi > 5
        ss = load(files{fi});
        dataS = double(ss.data);
    else
        dataS=load(files{fi});
    end
    
    % If we have a odd number of datapoints, cut off the last one
    if mod(size(dataS, 1), 2) == 1
        dataS(end,:) = [];
        %dataS(:,end) = [];
    end    
    
    script_helper(fi, dataS, kkVec);
end

matlabpool close;

%% Plot results
for fi = 1:nFiles    
    vals=[1 1 1];
    valX=[1 1 1];
    for kk=2:6:22
        s=sprintf('run_8set%d.%d.mat',fi,kk); % b-matching plot
        % Note that this comes from vbmatching, which runs until
        % convergence. So it will certainly do better than the b-symmetric
        % plot.
        load(s);
        s=sprintf('rununi_8set%d.%d.mat',fi,kk); % k-anonymity plot
        load(s);
        vals=[vals; kk (size(S,1)*size(S,2)-sum(sum(S)))/(size(S,1)*size(S,2))  (size(S2,1)*size(S2,2)-sum(sum(S2)))/(size(S2,1)*size(S2,2))];
        sum(sum(S2))
        s=sprintf('runagg_8set%d.%d.mat',fi,kk); % b-symmetric plot
        load(s);
        valX=[valX; kk (size(S,1)*size(S,2)-sum(sum(S)))/(size(S,1)*size(S,2))  (size(S2,1)*size(S2,2)-sum(sum(S2)))/(size(S2,1)*size(S2,2))];
    end    
    clf; plot(vals(:,1),vals(:,2));  % b-matching
    hold on;
    plot(valX(:,1),valX(:,2),'g.-'); % b-symmetric
    plot(vals(:,1),vals(:,3),'r--'); % k-anonymity
    plot(vals(:,1),(size(S,1)+2)./vals(:,1));
    kkk=1:1:max(vals(:,1));
    n=size(S,1);
    % plot(kkk,n./(n*kkk-kkk),'k:');
    xlabel('anonymity');ylabel('utility');
    axis([0 20 0 1])
    h=gca;
    set(h,'FontSize',26);xlabel('anonymity');ylabel('utility'); legend('b-matching','b-symmetric','k-anonymity','Location','SouthWest');
    sss=sprintf('n=%d d=%d nd=%d',size(S,1),size(S,2),size(S,1)*size(S,2));
    % title(sss);
    ss=sprintf('figbothPerf_KT_MAY27_%d.eps',fi);    
    print('-depsc',ss);    
end
    
