function script_2(fi, ik, varargin)

    p = inputParser;
    p.addRequired('fi', @isscalar);
    p.addRequired('ik', @isscalar);    
    
    p.parse(fi, ik, varargin{:});
    o = p.Results;
    
    dbstop if error;

    files{1}='bupa.bin';
    files{2}='wine.bin';
    files{3}='heart.bin';
    files{4}='ecoli.bin';
    files{5}='hepatitis.bin';
    files{6}='wdbc.mat';
    files{7}='auto-mpg.mat';
    files{8}='forestfires.mat';    

    kkVec = 20:-6:1;
    kk = kkVec(ik);

    %% Single fi iteration
    if fi > 5
        ss = load(files{fi});
        dataS = double(ss.data);
    else
        dataS=load(files{fi});
    end

    [N, D] = size(dataS);
    if mod(N, 2) == 1 % odd
        dataS(end,:) = [];
    end

    %% Begin with agglomerative, which we load
    if fi > 5
        % Sorry for the misleading name
        s = sprintf('social_4set_runagg_2%d.%d.mat', fi, kk);
    else
        s = sprintf('runagg_8set%d.%d.mat', fi, kk);
    end

    agg = load(s);

    [B, S] = gvbm(dataS, kk, 'gvbm_uci_uni_runlog_2', 'symmetric', true, 'roundMe', false, 'tempInit', 1);
    s = sprintf('rununi_8set_cold_%d.%d.mat', fi, kk);
    save(s, 'B', 'S');
    uniStars = sum(S(:));

    [B, S] = gvbm(dataS, kk, 'gvbm_uci_vb_runlog_2', 'symmetric', false, 'tempInit', 1);
    s = sprintf('run_8set_cold_%d.%d.mat', fi, kk);
    save(s, 'B', 'S');
    vbStars = sum(S(:));
        
    out = sprintf('starlog_cold_%d.%d', fi, ik);
    fid = fopen(out, 'a');        
    for io = [1 fid]
        fprintf(io, '*** OPTIONS ***\n');
        fprintf(io, toString(o, 'disp'));
        fprintf(io, '*** STAR SUMMARY ***\n');
        fprintf(io, 'agg: %d, uni: %d, vb: %d\n', sum(agg.S2(:)), uniStars, vbStars);
    end
    fclose(fid);
end
