function script_3_cold(fi, ik, varargin)

    p = inputParser; 
    p.addRequired('fi', @isscalar);
    p.addRequired('ik', @isscalar);
    p.addParamValue('vbTempInit', -1);
    p.addParamValue('uniTempInit', 5);
    
    p.parse(fi, ik, varargin{:});
    o = p.Results;
    
    dbstop if error;

    files{1}='bupa.bin';
    files{2}='wine.bin';
    files{3}='heart.bin';
    files{4}='ecoli.bin';
    files{5}='hepatitis.bin';
    files{6}='wdbc.mat';
    files{7}='auto-mpg.mat';
    files{8}='forestfires.mat';    

    kkVec = 20:-6:1;
    kk = kkVec(ik);

    %% Single fi iteration
    if fi > 5
        ss = load(files{fi});
        dataS = double(ss.data);
    else
        dataS=load(files{fi});
    end

    [N, D] = size(dataS);
    if mod(N, 2) == 1 % odd
        dataS(end,:) = [];
    end
    
    aggPath = sprintf('uci_results/runagg_8set%d.%d.mat', fi, kk);
    agg = load(aggPath);

%    % Cold start the VB.
%    [B, S, W] = gvbm(dataS, kk, 'gvbm_uci_vb_runlog_3', 'symmetric', false, 'tempInit', o.vbTempInit);
%    s = sprintf('uci_results/run_8set_cold_%d.%d.mat', fi, kk);
%    save(s, 'B', 'S', 'W');
%    vbStars = sum(S(:));    

    s = sprintf('uci_results/run_8set_cold_%d.%d.mat', fi, kk);
    vb = load(s);
    vbStars = sum(vb.S(:));  
    W = vb.W;
        
    [B, S] = gvbm(dataS, kk, 'gvbm_uci_uni_runlog_3', 'symmetric', true, 'roundMe', false, 'tempInit', o.uniTempInit, 'Winit', W);
    s = sprintf('uci_results/rununi_8set_cold_2_%d.%d.mat', fi, kk);
    save(s, 'B', 'S');
    uniStars = sum(S(:));
        
    out = sprintf('starlog_cold_2_%d.%d', fi, ik);
    fid = fopen(out, 'a');        
    for io = [1 fid]
        fprintf(io, '*** OPTIONS ***\n');
        fprintf(io, toString(o, 'disp'));
        fprintf(io, '*** STAR SUMMARY ***\n');
        fprintf(io, 'agg: %d, uni: %d, vb: %d\n', sum(agg.S2(:)), uniStars, vbStars);
    end
    fclose(fid);
end
