dbstop if error;
matlabpool open 12;

fprintf(1, 'Dataset %n, agglomerative\n', n);

%% Pre-process the social network data
files{1}='bupa.bin';
files{2}='wine.bin';
files{3}='heart.bin';
files{4}='ecoli.bin';
files{5}='hepatitis.bin';
files{6}='wdbc.mat';
files{7}='auto-mpg.mat';
files{8}='forestfires.mat';

nFiles = length(files);

kkVec = 20:-6:1;
nKK   = length(kkVec);

% Silly array stuff to avoid transparency violation

% If we have a odd number of datapoints, cut off the last one
if n > 5
    ss = load(files{n});
    dataS = double(ss.data);
else
    dataS=load(files{n});
end

if mod(size(dataS, 1), 2) == 1
    dataS(end,:) = [];
    %dataS(:,end) = [];
end    

for i = 1:nKK
    kk = kkVec(i);

    Ia = cell(12, 1);
    Ba = cell(12, 1);
    Sa = cell(12, 1);
    parfor t = 1:12
        [~, Ba{t}, Sa{t}] = fast_agglomerative(dataS, kk);
    end

    starVec = cellfun(@(S) sum(S(:)), Sa);
    [~, iMin] = min(starVec);

    B2  = Ba{iMin};
    S2  = Sa{iMin};

    s = sprintf('social_4set_runagg_2%d.%d.mat', n, kk);
    save(s);
end

matlabpool close;
