function script_helper(fi, dataS, kkVec)
    [N, D] = size(dataS);

    T = 10;
    save test_save.mat
    
    fn  = sprintf('infallible_runlog_%d', fi);
    fid = fopen(fn, 'w');
    
    for kk = kkVec
        % Take the best of T runs.
        mm = Inf;
        for t = 1:T
            [~, Btry, Stry] = fast_agglomerative(dataS, kk);
            sm = sum(Stry(:));
            if sm < mm
                mm = sm;
                B2 = Btry;
                S2 = Stry;
            end
        end
        s=sprintf('runagg_8set%d.%d.mat',fi,kk);
        save(s, 'B2', 'S2');        
        
        % Guarantee improvement. After all, it's a relaxation.
        % Setting the temperature to 1 allows us to use the optimal
        % setting.
        [B, S] = gvbm(dataS, kk, 'gvbm_uci_uni_runlog', 'symmetric', true, 'tempInit', 1, 'Ginit', B2);
        s = sprintf('rununi_8set%d.%d.mat', fi, kk);
        save(s, 'B', 'S');
        uniStars = sum(S(:));
        
        [B, S] = gvbm(dataS, kk, 'gvbm_uci_vb_runlog', 'tempInit', 1, 'Ginit', B);
        s = sprintf('run_8set%d.%d.mat', fi, kk);
        save(s, 'B', 'S');
        vbStars = sum(S(:));
        
        fprintf(fid, '*** STAR SUMMARY ***');
        fprintf(fid, 'agg: %d, uni: %d, vb: %d', sum(S2(:)), uniStars, vbStars);
    end
end
