%% Paths
addpath blossom

%% Convert text files to MATLAB matrices
%data = load('bupa.txt');
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii bupa.bin data
%
%data = load('wine.txt');
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii wine.bin data
%
%load('heart.mat');
%data = [xxx yyy];
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii heart.bin data
%
%load('ecoli.mat');
%data = [xxx yyy];
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii ecoli.bin data
%
%load('hepatitis.mat');
%data = [xxx yyy];
%[n,d]=size(data); for k=1:d;   mm = median(data(:,k));  if (sum(data(:,k)>mm-1e-4)==n) data(:,k) = (data(:,k)<mm+1e-4); else data(:,k) = (data(:,k)>mm-1e-4); end; end; imagesc(data);
%save -ascii hepatitis.bin data
%
%


%% Run the algos
matlabpool open 4;
dbstop if error;

files=cell(5,1);
files{1}='bupa.bin';
files{2}='wine.bin';
files{3}='heart.bin';
files{4}='ecoli.bin';
files{5}='hepatitis.bin';

kkVec = 20:-6:1;
nKK   = length(kkVec);

Bs{5,nKK} = '';
Ss{5,nKK} = '';
Bv{5,nKK} = '';
Sv{5,nKK} = '';

for fi=1:5
    dataS=load(files{fi});
    
    % If we have a odd number of datapoints, cut off the last one
    if mod(size(dataS, 1), 2) == 1
        dataS(end,:) = [];
    end
    
    parfor ik = 1:nKK
        kk = kkVec(ik);
        %pause(0.1);
        %[B,S]=vbmatching(dataS,kk,0.8);  s=sprintf('run%d.%d.mat',fi,kk); save(s,'S');
        [Bs{fi,ik}, Ss{fi,ik}]=unimatching_perfect_rand(dataS, kk);
        %[Bv{fi,ik}, Sv{fi,ik}]=vbmatching(dataS, kk, 0.8);
        %[IDX,B2,S2]=agglomerative(dataS,kk);  s=sprintf('runagg%d.%d.mat',fi,kk);  save(s,'S2');
    end

    %save('backup_uni_res.mat', 'Bs', 'Ss', 'Bv', 'Sv'); 
end
matlabpool close;


% Do the saving outside...
for fi = 1:5
    for ik = 1:nKK
        kk = kkVec(ik);

%        B = Bv{fi,ik};
%        S = Sv{fi,ik};
%        s = sprintf('run%d.%d.mat',fi,kk);
%        save(s,'S');
%
        B = Bs{fi,ik};
        S = Ss{fi,ik};
        s = sprintf('rununi_perfect_rand%d.%d.mat',fi,kk);
        save(s,'S');
    end
end

%% Plot results
for fi = 1:5    
    vals=[1 1 1];
    valX=[1 1 1];
    for kk=2:6:22
        s=sprintf('run%d.%d.mat',fi,kk); % b-matching plot
        load(s);
        s=sprintf('runagg%d.%d.mat',fi,kk); % k-anonymity plot
        load(s);
        vals=[vals; kk (size(S,1)*size(S,2)-sum(sum(S)))/(size(S,1)*size(S,2))  (size(S2,1)*size(S2,2)-sum(sum(S2)))/(size(S2,1)*size(S2,2))];
        sum(sum(S2))
        s=sprintf('rununi%d.%d.mat',fi,kk); % b-symmetric plot
        load(s);
        valX=[valX; kk (size(S,1)*size(S,2)-sum(sum(S)))/(size(S,1)*size(S,2))  (size(S2,1)*size(S2,2)-sum(sum(S2)))/(size(S2,1)*size(S2,2))];
    end    
    clf; plot(vals(:,1),vals(:,2));  % b-matching
    hold on;
    plot(valX(:,1),valX(:,2),'g.-'); % b-symmetric
    plot(vals(:,1),vals(:,3),'r--'); % k-anonymity
    plot(vals(:,1),(size(S,1)+2)./vals(:,1));
    kkk=1:1:max(vals(:,1));
    n=size(S,1);
    % plot(kkk,n./(n*kkk-kkk),'k:');
    xlabel('anonymity');ylabel('utility');
    axis([0 20 0 1])
    h=gca;
    set(h,'FontSize',26);xlabel('anonymity');ylabel('utility'); legend('b-matching','b-symmetric','k-anonymity','Location','SouthWest');
    sss=sprintf('n=%d d=%d nd=%d',size(S,1),size(S,2),size(S,1)*size(S,2));
    % title(sss);
%    ss=sprintf('figbothPerf_KT_MAY7_%d.eps',fi);    
%    print(1,'-depsc',ss);    
end
    
