function social_script_2_finalpush(fi, ki, vbTemp)
    dataPath = '/proj/learning/Matching/facebook100';

    social{1} = 'Caltech36';
    social{2} = 'Reed98';
    social{3} = 'Haverford76';
    social{4} = 'Simmons81'
    nFeatures = 7;

    kkVec = 26:-6:6;
    
    raw = load(fullfile(dataPath, social{fi}));
    friends = full(sum(raw.A, 2));
    logFriends = ceil(log(friends));
    
    %bBase = (max(logFriends1) - logFriends1 + 1) ./ logFriends1;
    bBase = max(logFriends) - logFriends;
    maxBBase = max(bBase);
    
    X = binarizeLocalInfo(raw.local_info);
    N = size(X, 1);
    
    if mod(N, 2) == 1
        X(end,:) = [];
        N = N - 1;
        bBase(end) = [];
        logFriends(end) = [];
    end
    
    maxKK = kkVec(ki);
    minKK = maxKK - maxBBase;
    b = minKK + bBase
    
    %aggPath = sprintf('social_4set_runagg%d.%d.mat', fi, maxKK);
    runLog  = sprintf('runlog_social_4set%d.%d',     fi, maxKK);
    %agg     = load(aggPath);
    
    % We run out of memory without roundMe!
    %[B, S] = gvbm(X, b, runLog, 'symmetric', true, 'Ginit', agg.B2, 'tempInit', 1, 'roundMe', true);
    %s = sprintf('social_4set_rununi%d.%d.mat', fi, ki);
    %save(s, 'B', 'S');

    uniPath = sprintf('social_results/social_4set_rununi%d.%d.mat', fi, ki);
    uni     = load(uniPath);
    
    [B, S] = gvbm(X, b, runLog, 'symmetric', false, 'Ginit', uni.B, 'tempInit', vbTemp);
    s = sprintf('social_4set_run%d.%d.mat', fi, ki);
    save(s, 'B', 'S');
end
