function social_script_3(fi, ki, varargin)
    dataPath = '/proj/learning/Matching/facebook100';
    dbstop if error;

    p = inputParser; 
    p.addRequired('fi', @isscalar);
    p.addRequired('ki', @isscalar);
    p.addParamValue('vbTempInit', -1);
    p.addParamValue('uniTempInit', 1);

    p.parse(fi, ki, varargin{:});
    o = p.Results;

    social{1} = 'Caltech36';
    social{2} = 'Reed98';
    social{3} = 'Haverford76';
    social{4} = 'Simmons81'
    nFeatures = 7;

    kkVec = 26:-6:6;
    
    raw = load(fullfile(dataPath, social{fi}));
    friends = full(sum(raw.A, 2));
    logFriends = ceil(log(friends));
    
    %bBase = (max(logFriends1) - logFriends1 + 1) ./ logFriends1;
    bBase = max(logFriends) - logFriends;
    maxBBase = max(bBase);
    
    X = binarizeLocalInfo(raw.local_info);
    N = size(X, 1);
    
    if mod(N, 2) == 1
        X(end,:) = [];
        N = N - 1;
        bBase(end) = [];
        logFriends(end) = [];
    end
    
    maxKK = kkVec(ki);
    minKK = maxKK - maxBBase;
    b = minKK + bBase;

    runLog  = sprintf('runlog_social_cold_4set%d.%d',     fi, maxKK);
     
    % Cold start the VB.
    [B, S, W] = gvbm(X, maxKK, 'gvbm_uci_vb_runlog_3', 'symmetric', false, 'tempInit', o.vbTempInit);
    s = sprintf('social_results/social_4set_run%d.%d.mat', fi, maxKK);
    save(s, 'B', 'S', 'W');
    vbStars = sum(S(:));    

    uniPath = sprintf('social_results/social_4set_rununi%d.%d.mat', fi, ki);
    uni     = load(uniPath); 

    [B, S]  = gvbm(X, b, runLog, 'symmetric', false, 'Winit', W, 'tempInit', o.uniTempInit);

    s = sprintf('social_4set_run%d.%d.mat', fi, ki);
    save(s, 'B', 'S');
end
