function [Gfinal,Sfinal]=unimatching(X,kkk,epsilon)
%
% function [Gfinal,Sfinal]=unimatching(X,kkk,epsilon)
% 
% Bmatching with at least k connections
% epsilon controls the variational bound
% outputs G is an adjacency matrix
% outputs S is the star pattern
%

if (nargin<3)
  epsilon=1E-5;
end


[n,d]=size(X);

W=ones(n,d);
W=W/sum(sum(W));

Sold = n*d;
Snew = Sold-1;
costos=[];
costo=Sold;
costn=Snew;
Strail = round(rand(1,20)*10000);

zzz = 1;
maxzzz=80;

Gold=zeros(n,n);

fid = fopen('runlog','a');

Sfinal = ones(size(X));

fprintf(1,'n=%d d=%d k=%d\n',n,d,kkk); fprintf(fid,'n=%d d=%d k=%d\n',n,d,kkk);

while (zzz<maxzzz)

  costo=costn;
  
  D=zeros(n,n);
  for i=1:n
    for j=1:n
      D(i,j)=sum(W(i,:).*(X(i,:)~=X(j,:)));
    end
  end
  % D = D+rand(size(D))*1e-4; % Rand to break ties may be unnecessary
  D = max(max(D))-D;
  for i=1:n;D(i,1:i)=0;end;

  %G = edmondsreduction(D,kkk-1);
  % bmatch(D, k, perfect, verbose)
  %G = bmatch(D, kkk-1, false, false);  
  
  % A little test
  G1 = edmondsreduction(D, kkk - 1);
  G2 = double(bmatch(D, kkk - 1, true, false));
  %G3 = double(bmatch(D, kkk - 1, false, false));
  
  %assert(all(vec(G1 == G2)));
  
  G = G2;
  
  for i=1:n
    G(i,i)=1;
  end
  fprintf(1,'Old value %e ',sum(sum(Gold.*D)));  fprintf(fid,'Old value %e ',sum(sum(Gold.*D)));
  fprintf(1,' new value %e\n',sum(sum(G.*D)));  fprintf(fid,' new value %e\n',sum(sum(G.*D)));
  S=zeros(size(X));
  for i=1:n
    for j=1:n
      if (G(i,j)>0.5)
        for dd=1:d
          if (X(i,dd)~=X(j,dd))
            S(i,dd)=1;
          end
        end
      end
    end
  end

  Snew=sum(sum(S));
  if (Snew<sum(sum(Sfinal)))
    Sfinal=S;
    Gfinal=G;
  end

  if (Snew>Sold)
    G=Gold;
    Snew=Sold;
  else
    Gold=G;
    Sold=Snew;
  end

  costn = 0;
  for i=1:n
    for k=1:d
      costn = (1+epsilon)^n-prod(1+epsilon-G(i,:).*(X(i,k)~=X(:,k)'));
      W(i,k) = n*log(1+epsilon)+sum(G(i,:).*(X(i,k)~=X(:,k)'))*log(epsilon/(1+epsilon));
    end
  end
  fprintf(1,'Iter=%d Stars=%d Cost=%e Epsilon=%f\n',zzz,Snew,costn,epsilon);
  fprintf(fid,'Iter=%d Stars=%d Cost=%e Epsilon=%f\n',zzz,Snew,costn,epsilon);
  epsilon=epsilon*0.8;
  zzz=zzz+1;

  W=W-max(max(W));
  W=exp(W);
%  W=W/(sum(sum(W)));

  Strail = [Strail Snew];

%  if (length(unique(Strail(end-40:end)))<=1)
%    zzz=maxzzz+1;
%  end

end

fclose(fid);
