function [Gfinal,Sfinal]=unimatchingONCLUSTER(X,kkk,epsilon)
%
% function [Gfinal,Sfinal]=unimatching(X,kkk,epsilon)
% 
% Bmatching with at least k connections
% epsilon controls the variational bound
% outputs G is an adjacency matrix
% outputs S is the star pattern
%



[n,d]=size(X);

W=ones(n,d);
W=W/sum(sum(W));

Sold = n*d;
Snew = Sold-1;
costos=[];
costo=Sold;
costn=Snew;
Strail = round(rand(1,20)*10000);

zzz = 1;
maxzzz=200;

Gold=zeros(n,n);

fid = fopen(sprintf('runlog_slow_anneal_n%d_k%d_%s', size(X, 1), kkk, datestr(now)), 'w');

Sfinal = ones(size(X));

fprintf(1,'n=%d d=%d k=%d\n',n,d,kkk); fprintf(fid,'n=%d d=%d k=%d\n',n,d,kkk);

temperature = -5.3;

while (zzz<maxzzz)

  costo=costn;
  
  D=zeros(n,n);
  for i=1:n
    for j=1:n
      D(i,j)=sum(W(i,:).*(X(i,:)~=X(j,:)));
    end
  end
  D = D+rand(size(D))*1e-4; % Rand to break ties may be unnecessary
  D = max(max(D))-D;
  for i=1:n;D(i,1:i)=0;end;

  %G = edmondsreduction(D,kkk-1);
  G = double(bmatch(D, kkk - 1, false, false));
    
  for i=1:n
    G(i,i)=1;
  end
  fprintf(1,'Old value %e ',sum(sum(Gold.*D)));  fprintf(fid,'Old value %e ',sum(sum(Gold.*D)));
  fprintf(1,' new value %e\n',sum(sum(G.*D)));  fprintf(fid,' new value %e\n',sum(sum(G.*D)));
  S=zeros(size(X));
  for i=1:n
    for j=1:n
      if (G(i,j)>0.5)
        for dd=1:d
          if (X(i,dd)~=X(j,dd))
            S(i,dd)=1;
          end
        end
      end
    end
  end

  Snew=sum(sum(S));
  if (Snew<sum(sum(Sfinal)))
    Sfinal=S;
    Gfinal=G;
  end

%  if (Snew>Sold)
%    G=Gold;
%    Snew=Sold;
%  else
    Gold=G;
    Sold=Snew;
%  end

  costn = 0;
  for i=1:n
    for k=1:d
      W(i,k) = sum(G(i,:).*(X(i,k)~=X(:,k)'));
    end
  end
  
  if (temperature<0)
    temperature=2*max(max(W));
  else
    temperature=temperature*0.95;
  end

  fprintf(1,'Iter=%d Stars=%d temperature=%f\n',zzz,Snew,temperature);
  fprintf(fid,'Iter=%d Stars=%d temperature=%f\n',zzz,Snew,temperature);
  zzz=zzz+1;

  W=-W/temperature;
  W=W-max(max(W));
  W=exp(W);

  Strail = [Strail Snew];

%  if (length(unique(Strail(end-40:end)))<=1)
%    zzz=maxzzz+1;
%  end

end

fclose(fid);
