function [Gfinal,Sfinal]=vbmatchingLOOPY(X,kkk,epsilon)
%
% function [Gfinal,Sfinal]=vbmatchingLOOPY(X,kkk,epsilon)
% 
% Bmatching with at least k connections
% epsilon controls the variational bound
% outputs G is an adjacency matrix
% outputs S is the star pattern
%

if (nargin<3)
  epsilon=1E-5;
end


[n,d]=size(X);

W=ones(n,d);
W=W/sum(sum(W));

Sold = n*d;
Snew = Sold-1;
costos=[];
costo=Sold;
costn=Snew;
G  = round(rand(n,n));
Go = round(rand(n,n));

zzz = 1;
Zn=zeros(n,n);
On=ones(n,n);

while (max(max(G-Go))>0.5)
  Sold=Snew;
  costo=costn;
  
  D=zeros(n,n);
  for i=1:n
    for j=1:n
      D(i,j)=sum(W(i,:).*(X(i,:)~=X(j,:)));
    end
  end
  D = D+rand(size(D))*1e-4;

  notD = max(max(D))-D;
  [P]=loopyB([Zn notD; notD Zn],[Zn On; On Zn],kkk);
  P=full(P);
  Go = G;
  G = P(1:n,n+1:2*n);
 
  for i=1:n
    for j=1:n
      if (G(i,j)>0.5)
        for dd=1:d
          if (X(i,dd)~=X(j,dd))
            S(i,dd)=1;
          end
        end
      end
    end
  end

  Snew=sum(sum(S));
  costn = n*d;
  for i=1:n
    for k=1:d
     costn = costn-prod(1+epsilon-G(i,:).*(X(i,k)~=X(:,k)'));
      W(i,k) = n*log(1+epsilon)+sum(G(i,:).*(X(i,k)~=X(:,k)'))*log(epsilon/(1+epsilon));
    end
  end
  fprintf(1,'Iter=%d Stars=%d Cost=%f\n',zzz,Snew,costn);
  zzz=zzz+1;
  % costos=[costos; Snew costo]; plot(costos); pause(0.0001);
  W=W-max(max(W));
  W=exp(W);
  W=W/(sum(sum(W)));
  if (Snew<Sold)
    Sfinal=S;
    Gfinal=G;
  end
end


