function [Gfinal,Sfinal]=unimatchingONCLUSTER(X,kkk,factor)
%
% function [Gfinal,Sfinal]=unimatching(X,kkk,epsilon)
%
% Bmatching with at least k connections
% epsilon controls the variational bound
% outputs G is an adjacency matrix
% outputs S is the star pattern
%



[n,d]=size(X);

W=ones(n,d);
W=W/sum(sum(W));

Sold = n*d;
Snew = Sold-1;
costos=[];
costo=Sold;
costn=Snew;
Strail = round(rand(1,20)*10000);

N = n*n;

zzz = 1;
maxzzz=200;

Gold=zeros(n,n);

fn  = sprintf('runlog_vb_temp_may27_n%d_d%d_maxk%d', n, d, max(kkk));
fid = fopen(fn, 'w');

Sfinal = ones(size(X));

fprintf(1,'n=%d d=%d maxk=%d\n',n,d,max(kkk)); fprintf(fid,'n=%d d=%d maxk=%d\n',n,d,max(kkk));

temperature = -4.3;

A = zeros(2*n,n*n); b=zeros(2*n,1); Aeq = []; beq = [];
% vectorize the kkk
if length(kkk) == 1
    kkk = kkk * ones(n, 1);
end

assert(length(kkk) == n, 'kkk must be of length n');    

opts = optimset('MaxIter', 1000);

while (zzz<maxzzz)
    
    costo=costn;
    
    D=zeros(n,n);
    for i=1:n
        for j=1:n
            D(i,j)=sum(W(i,:).*(X(i,:)~=X(j,:)));
        end
    end
    D = D+rand(size(D))*1e-4; % Rand to break ties may be unnecessary
    D = max(max(D))-D;
    for i=1:n;D(i,1:i)=0;end;
    
    %G = edmondsreduction(D,kkk-1);

      f = -reshape(max(max(D))-D,n*n,1);
      for i=1:n
        A1 = zeros(1,N);
        for j=1:n
          A1(n*(i-1)+j)=1;
        end
        A(i,:) = A1;
        b(i) =  kkk(i);
      end
      for i=1:n
        A1 = zeros(1,N);
        for j=1:n
          A1(n*(j-1)+i)=1;
        end
        A(i+n,:) = A1;
        b(i+n) = kkk(i);
      end
      % X = LINPROG(f,A,b,Aeq,beq,LB,UB,X0,OPTIONS)
      x=linprog(f,A,b,Aeq,beq,zeros(size(f)),ones(size(f)),[],opts);
      G  = zeros(n,n);
      for i=1:n
        for j=1:n
          G(i,j)=x(n*(j-1)+i);
        end
      end
      S=zeros(size(X));
      G=round(G);
      for i=1:n
        for j=1:n
          if (G(i,j)>0.5)
            for dd=1:d
              if (X(i,dd)~=X(j,dd))
                S(i,dd)=1;
              end
            end
          end
        end
      end

    if ~all(sum(G, 2) == kkk - 1)
        disp('Imperfection achieved');
    end
    
    %Gperf = double(bmatch(D, kkk - 1, true, false));
    
    % Diagnostic:
    
    
    for i=1:n
        G(i,i)=1;
    end
    fprintf(1,'Old value %e ',sum(sum(Gold.*D)));  fprintf(fid,'Old value %e ',sum(sum(Gold.*D)));
    fprintf(1,' new value %e\n',sum(sum(G.*D)));  fprintf(fid,' new value %e\n',sum(sum(G.*D)));
    S=zeros(size(X));
    for i=1:n
        for j=1:n
            if (G(i,j)>0.5)
                for dd=1:d
                    if (X(i,dd)~=X(j,dd))
                        S(i,dd)=1;
                    end
                end
            end
        end
    end
    
    Snew=sum(sum(S));
    if (Snew<sum(sum(Sfinal)))
        Sfinal=S;
        Gfinal=G;
    end
    
    % Don't move to a higher energy state!
%    if (Snew>Sold)
%        G=Gold;
%        Snew=Sold;
%    else
        Gold=G;
        Sold=Snew;
%    end
    
    costn = 0;
    for i=1:n
        for k=1:d
            W(i,k) = sum(G(i,:).*(X(i,k)~=X(:,k)'));
        end
    end
    
    if (temperature<0)
        %temperature=factor*max(max(W));
        temperature=2*max(max(W));
    else
        temperature=temperature*0.92;
    end
    
    fprintf(1,'Iter=%d Stars=%d temperature=%f\n',zzz,Snew,temperature);
    fprintf(fid,'Iter=%d Stars=%d temperature=%f\n',zzz,Snew,temperature);
    zzz=zzz+1;
    
    W=-W/temperature;
    W=W-max(max(W));
    W=exp(W);
    
    Strail = [Strail Snew];
    
    % If the last 40 iterations didn't change the star count
    if zzz > 40 && length(unique(Strail(end-40:end))) <= 1
        zzz=maxzzz+1;
    end
    
end

fclose(fid);
