function [ri, rj, rw, em, periNodes, neg] = fullBondyMurty(W,b1)

    n = size(W,1);    
    if (b1<(n/2))
      b=n-b1-1;
      Wbb=W;
      neg = true;
    else
      b=b1;
      Wbb=-W;
      neg = false;
    end
    
    minW = min(W(:));
    maxW = max(W(:));
    
    Wbb = round(20000000*(Wbb-minW)/(maxW-minW)+1);
    Wu  = triu(Wbb);
    Wbb = Wu + Wu';

    fid = fopen('GRAPH.TXT','w');
    fprintf(fid,'c graph in DIMACS format \n');
    E=zeros(n,n);
    ind=1;
    for i=1:n
      for j=(i+1):n
        E(i,j)=ind; ind=ind+1;
      end
    end
    for j=1:n
      for i=(j+1):n
        E(i,j)=ind; ind=ind+1;
      end
    end
    fprintf(fid,'p edge %d %d\n',n*(n-1)+n*(n-1-b),n*(n-1)/2+n*(n-1-b)*(n-1));

    minmin=min(min(Wbb));
    for i=1:n
      for j=1:n
        if (i~=j)
          if (E(i,j)<E(j,i))
            fprintf(fid,'e %d %d %d\n',E(i,j),E(j,i),Wbb(i,j));
          end
        end
      end
    end
    for i=1:n
      for j=1:n
        if (i~=j)
          for k=1:(n-1-b) % Add (degree-b), but degree=(n-1) in full graph
            fprintf(fid,'e %d %d %d\n',E(i,j),n*(n-1)+(i-1)*(n-1-b)+k,0); % (i,j));
          end
        end
      end
    end
    fclose(fid);
    system('./blossom5-v2.03.src/blossom5 -V -e GRAPH.TXT -w OUTPUT.TXT > /dev/null');
    Ps=load('OUTPUT.TXT');
    Ps=Ps+1;
    P=zeros(n,n);
    m=n*(n-1);
    for k=2:size(Ps,1)
      edge1=Ps(k,1);
      edge2=Ps(k,2);
      if (max(edge1,edge2)<=m)
        [i,j]=find(E==edge1);
        [ii,jj]=find(E==edge2);
        P(i,j)=1;
        P(j,i)=1;
        P(ii,jj)=1;
        P(jj,ii)=1;
      end
    end

    if (b1<(n/2))
      P=1-P;
      for i=1:n
        P(i,1:i)=0;
      end;
      P=max(P,P');
    end

    cd(zz)


end
