dbstop if error;

%% Network plot (spectral embedding)
if clicLab
    dataPath = '/proj/learning/Matching/facebook100';
else
    dataPath = '/Users/kuitang/Datasets/facebook100';
end

social{1} = 'Caltech36';
social{2} = 'Reed98';
social{3} = 'Haverford76';
social{4} = 'Simmons81';
nFeatures = 7;
uniTemplate = 'social_results/social_4set_rununi%d.%d.mat';

kkVec = 26:-6:6;

%% for loop
fids = [1 2];
for fi = fids    
    %% One iter    
    raw = load(fullfile(dataPath, social{fi}));
    %rixs = randsample(1:size(raw.A, 1), 100);        
    
    rixs = 1:size(raw.A, 1);
    
    %hRaw = figure;        
    
%     [AV, AD] = eig(full(raw.A));
%     figure;
%     bar(diag(AD));
%     title(sprintf('Eigenspectrum of A; fi = %d', fi));
    
    [~, AX, latent]  = princomp(full(raw.A));
    
%     figure;
%     bar(latent);
%     title(sprintf('Latents (explain variance?), fi = %d', fi))
    
    h = figure;
    scatter(AX(:,1), AX(:,2), 4, 'b', 'filled')
    title(sprintf('A%d', fi));
    
    print(h, '-depsc', sprintf('social_results/A.%d.eps', fi));
        
    for ik = 1:length(kkVec);
        kk = kkVec(ik);
        s = sprintf(uniTemplate, fi, ik);
        uni = load(s);
        
        
        [~, BX, latent] = princomp(uni.B);
        
%         h2 = figure;
%         bar(latent);
%         title(sprintf('Latents, fi = %d, kk = %d', fi, kk));
        
        h3 = figure;
        scatter(BX(:,1), BX(:,2), 4, 'b', 'filled');
        title(sprintf('B%d.%d', fi, kk));
        print(h3, '-depsc', sprintf('social_results/B%d.%d.eps', fi, kk));
        
        close(h3);
    end
end

