% Analyze the social network data.

% TO DOUBLE CHECK: Get a better result for Caltech %1

fids = [ 1 2 ];
%kkVec = 8:6:26;
kkVec = 26:-6:8;

%% Star plot
% Set the parameter
vbTemplate  = 'social_4set_run%d.%d.mat';
uniTemplate = 'social_4set_rununi%d.%d.mat';
aggTemplate = 'social_4set_runagg%d.%d.mat';

utils = zeros(length(fids), 3);
stars = zeros(length(fids), 3);
for fi = fids        
    %% For one file
    for ik = 1:length(kkVec)
        kk = kkVec(ik);
        utils(ik,1) = kk;        
        
        s = sprintf(vbTemplate, fi, ik)  ;      
        vb = load(s);   
        % See paper for equation
        stars(ik,1) = sum(vb.S(:));
        utils(ik,1) = 1 - sum(vb.S(:)) / numel(vb.S);
        
        s = sprintf(uniTemplate, fi, ik); % k-anonymity plot
        uni = load(s);
        stars(ik,2) = sum(uni.S(:));
        utils(ik,2) = 1 - sum(uni.S(:)) / numel(vb.S);
        
        s = sprintf(aggTemplate, fi, kk); % b-symmetric plot
        agg = load(s);
        stars(ik,3) = sum(agg.S2(:));
        utils(ik,3) = 1 - sum(agg.S2(:)) / numel(agg.S2);        
    end
        
    %% Now plot
    %plot(kkVec, utils);    
    fh = figure;
    plot(kkVec, utils(:,1), kkVec, utils(:,2), 'g.-', kkVec, utils(:,3), 'r--');
    
    % plot(kkk,n./(n*kkk-kkk),'k:');
    xlabel('anonymity');ylabel('utility');
    %axis([0 20 0 1])
    h=gca;
    set(h,'FontSize',26);xlabel('anonymity');ylabel('utility'); legend('b-matching','b-symmetric','k-anonymity','Location','SouthWest');
    
    % title(sss);       
    
    ss = sprintf('social_results/figure_%d.eps', fi);    
    print(fh, '-depsc',ss);    
end

