% Analyze the social network data.

% TO DOUBLE CHECK: Get a better result for Caltech %1

%kkVec = 8:6:26;
kkVec = 20:-6:2;

%% Star plot
% Set the parameter

if plotColds
    vbTemplate  = 'uci_results/run_8set_cold_%d.%d.mat';
    uniTemplate = 'uci_results/rununi_8set_cold_%d.%d.mat';
    %uniTemplate = 'uci_results/rununi_8set_cold_2_%d.%d.mat';
    aggTemplate = 'uci_results/runagg%d.%d.mat';
    %aggTemplate = 'uci_results/runagg_8set%d.%d.mat';

    
    fids = 1:5;
else
    % 8set runs
    %vbTemplate  = 'uci_results/run_8set_2_%d.%d.mat';
    %uniTemplate = 'uci_results/rununi_8set_2_%d.%d.mat';
    
    %aggTemplate = 'uci_results/runagg_8set%d.%d.mat';

    % New runs
    vbTemplate  = 'uci_results/run.%d.%d.mat';
    uniTemplate = 'uci_results/rununi.%d.%d.mat';    
    aggTemplate = 'uci_results/runagg%d.%d.mat';
    
    fids = 1:5;
    %fids = [1:5 8];
    %fids = 2:5;
end

utils = zeros(length(kkVec), 3);
stars = zeros(length(fids), 3);
for fi = fids        
    %% For one file
    for ik = 1:length(kkVec)
        kk = kkVec(ik);
        utils(ik,1) = kk;        
        
        s = sprintf(vbTemplate, fi, kk)  ;      
        vb = load(s);   
        % See paper for equation
        stars(ik,1) = sum(vb.S(:));
        utils(ik,1) = 1 - sum(vb.S(:)) / numel(vb.S);
        
        s = sprintf(uniTemplate, fi, kk); % k-anonymity plot
        uni = load(s);
        stars(ik,2) = sum(uni.S(:));
        utils(ik,2) = 1 - sum(uni.S(:)) / numel(vb.S);
        
        s = sprintf(aggTemplate, fi, kk); % b-symmetric plot
        agg = load(s);
        stars(ik,3) = sum(agg.S2(:));
        utils(ik,3) = 1 - sum(agg.S2(:)) / numel(agg.S2);        
    end
        
    %% Now plot
    %plot(kkVec, utils);    
    fh = figure;
    plot(kkVec, utils(:,1), kkVec, utils(:,2), 'g.-', kkVec, utils(:,3), 'r--');
    
    % plot(kkk,n./(n*kkk-kkk),'k:');
    xlabel('anonymity');ylabel('utility');
    %axis([0 20 0 1])
    h=gca;
    set(h,'FontSize',26);xlabel('anonymity');ylabel('utility'); legend('b-matching','b-symmetric','k-anonymity','Location','SouthWest');
    
    % title(sss);       
    
    if plotColds
        ss = sprintf('uci_results/cold_%d.eps', fi);
    else
        ss = sprintf('uci_results/warm_%d.eps', fi);
    end
    
    print(fh, '-depsc', ss);    
end
