function [Gfinal,Sfinal]=unimatching_tilde(X,kkk,epsilon)
%
% function [Gfinal,Sfinal]=unimatching(X,kkk,epsilon)
% 
% Bmatching with at least k connections
% epsilon controls the variational bound
% outputs G is an adjacency matrix
% outputs S is the star pattern
%

if (nargin<3)
  epsilon=1E-5;
end


[n,d]=size(X);

W=ones(n,d);
W=W/sum(sum(W));

Sold = n*d;
Snew = Sold-1;
costos=[];
costo=Sold;
costn=Snew;
Strail = round(rand(1,20)*10000);
G  = round(rand(n,n));

A = zeros(2*n,n*n); b=zeros(2*n,1); Aeq = []; beq = [];
zzz = 1;

while (length(unique(Strail(end-10:end)))>1)
  Sold=Snew;
  costo=costn;
  
  D=zeros(n,n);
  for i=1:n
    for j=1:n
      D(i,j)=sum(W(i,:).*(X(i,:)~=X(j,:)));
    end
  end
  D = D+rand(size(D))*1e-4;
  
  %[G,totiters]=edmondsblossom(max(max(D))-D,kkk,100,0.15);
  %G = double(bmatch(D, kkk - 1, true, false));
  %G = double(bmatch(D, kkk - 1, false, false));

  G = edmondsreduction(D, kkk - 1);
    

  S=zeros(size(X));
  for i=1:n
    for j=1:n
      if (G(i,j)>0.5)
        for dd=1:d
          if (X(i,dd)~=X(j,dd))
            S(i,dd)=1;
          end
        end
      end
    end
  end

  Snew=sum(sum(S));
  costn = n*d;
  for i=1:n
    for k=1:d
     costn = costn-prod(1+epsilon-G(i,:).*(X(i,k)~=X(:,k)'));
      W(i,k) = n*log(1+epsilon)+sum(G(i,:).*(X(i,k)~=X(:,k)'))*log(epsilon/(1+epsilon));
    end
  end
  fprintf(1,'Iter=%d Stars=%d Cost=%f Epsilon=%f\n',zzz,Snew,costn,epsilon);
  epsilon=epsilon*0.9;
  zzz=zzz+1;
  % costos=[costos; Snew costo]; plot(costos); pause(0.0001);
  W=W-max(max(W));
  W=exp(W);
  W=W/(sum(sum(W)));
  if (Snew<Sold)
    Sfinal=S;
    Gfinal=G;
  end
  Strail = [Strail Snew];
end


